SystemOrganization addCategory: #'Pier-Caching'!

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:40'!
command: aCommand critical: aBlock

	self pathCache invalidate: aCommand structure.
	self critical: aBlock

 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:39'!
pathCache

^ pathCache ifNil: [ pathCache := self pathCacheClass new ]

 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:32'!
pathCacheClass

^ PRPathCache
 ! !

Object subclass: #PRCachedPath
	instanceVariableNames: 'fullPath structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Caching'!

!PRCachedPath class methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 10:58'!
path: aString structure: aStructure

^self new 
	setFullPath: aString structure: aStructure; 
	yourself.! !

!PRCachedPath methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 10:58'!
fullPath

^fullPath! !

!PRCachedPath methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 10:58'!
setFullPath: aString structure: aStructure

fullPath := aString.
structure := aStructure.! !

!PRCachedPath methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 10:57'!
structure

^structure! !

Object subclass: #PRPathCache
	instanceVariableNames: 'byPath byStructure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Caching'!

!PRPathCache class methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 03:38'!
initialize

(PRPersistency instVarNames includes: 'pathCache') 
	ifFalse: [ PRPersistency addInstVarName: 'pathCache'. ]! !

!PRPathCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 03:53'!
initialize

byPath := Dictionary new.
byStructure := Dictionary new.! !

!PRPathCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 03:56'!
invalidate: aStructure

byPath removeKey: (byStructure removeKey: aStructure) fullPath.

! !

!PRPathCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 03:54'!
lookup: aPath startingAt: aStructure fallback: aBlock

aStructure isRoot ifFalse: [ ^aBlock value ].

^(byPath at: aPath ifAbsentPut: [ 
	byStructure at: aStructure 
				put: (PRCachedPath path: aPath structure: aBlock value) ]) structure! !

!PRObject methodsFor: '*pier-caching' stamp: 'kph 10/24/2006 17:07'!
withCacheDo: aBlock

| context |

(context := PRCurrentContext value) ifNil: [ ^nil ].

^ aBlock value: context kernel persistency.! !

!PRPathLookup class methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:40'!
start: aStructure path: aPathString

	^aStructure withCacheDo: [ :cache | 
		cache pathCache lookup: aPathString 
				startingAt: aStructure 
				fallback: [ self new stream: aPathString readStream; lookup: aStructure ] 
	]
			
 ! !
PRPathCache initialize!
